// Mark Stankus 1999 (c) 
// general.c 

#include "Sink.hpp"
#include "stringGB.hpp"
#include "Command.hpp"

void printAllCommands();

#include "load_flags.hpp"
#pragma warning(disable:4786)
#include "vcpp.hpp"
#ifndef INCLUDED_GBIO_H
#include "GBIO.hpp"
#endif
#include "MyOstream.hpp"

void getAllCommands(list<simpleString> & L) ;

void _PrintAllCommands(Source & so,Sink & si) {
  so.shouldBeEnd();
  printAllCommands();
  si.noOutput();
};

AddingCommand temp1general("PrintAllCommands",0,_PrintAllCommands);

void _GetAllCommands(Source & so,Sink & si) {
  so.shouldBeEnd();
  list<simpleString> L;
  getAllCommands(L);
  long sz  = L.size();
  Sink sink(si.outputFunction("List",sz));
  GBStream << "Begin loop\n";
  list<simpleString>::const_iterator w = L.begin();
  for(long i=1L;i<=sz;++i,++w) {
    sink.putString((*w).chars()); 
  };
  GBStream << "Done with " << sz << "elements!\n";
};

AddingCommand temp2general("GetAllCommands",0,_GetAllCommands);


void _NCGBQuit(Source &,Sink &) {
  exit(0);
};

AddingCommand temp3general("NCGBQuit",1,_NCGBQuit);

void NCGBComment(Source & so,Sink & si) {
  so.passString();
  so.shouldBeEnd();
  si.noOutput();
};

AddingCommand temp4general("NCGBComment",1,NCGBComment);

#include "StartEnd.hpp"

const char * s_version = "1.0.0";

class sayHiToUser : public AnAction {
public:
  sayHiToUser() : AnAction("sayHiToUser") {};
  void action() {
    GBStream << "You are using the program NCGB version " 
             << s_version << '\n';
  };
};

AddingStart temp1General(new sayHiToUser);
