// GroebnerRule.c

#include "GroebnerRule.hpp"
#include "OuMonomial.hpp"
#include "MyOstream.hpp"

MyOstream & operator <<(MyOstream & os,const GroebnerRule & x) {
  OuMonomial::NicePrint(os,x.LHS());
  os << " -> ";
  os << x.RHS();
  return os;
};

void GroebnerRule::convertAssign(const Polynomial & p) {
  if(p.zero()) {
    GBStream << "Warning: Converting the polynomial zero to a "
             << "groebner rule.\n";
    GBStream << "Result should be discarded.\n";
  } else {
    const Term & t = p.tip();
      // Do monomial
    _monomial = t.MonomialPart();
      // Do polynomial
    _polynomial = p;
    _polynomial.Removetip();
    Field temp(s_NegOne);
    temp /= t.CoefficientPart();
    _polynomial *= temp;
  };
};

INTEGER  GroebnerRule::s_NegOne(-1L);
Term     GroebnerRule::s_term;
