// (c) Mark Stankus 1999
// ISource.c

#include "ISource.hpp"
#include "symbolGB.hpp"
#include "StringAccumulator.hpp"
#include "GBInputNumbers.hpp"
#include "TellHead.hpp"
#include "Debug1.hpp"
#include "MyOstream.hpp"

ISource::~ISource() {};

void ISource::error() {
  DBG();
};

void ISource::get(bool & x) {
  symbolGB y;
  get(y);
  if(y=="True") {
    x = true;
  } else if(y=="False") {
    x = false;
  } else DBG();
};

void ISource::get(Field&) {
  DBG();
};

void ISource::get(Variable&) {
  DBG();
};

void ISource::getAnything(StringAccumulator & acc) {
  int type = getType();
  symbolGB y;
  if(type==GBInputNumbers::s_IOSYMBOL) {
    get(y);
    acc.add(y.value().chars());
  } else {
    Alias<ISource> iso(inputFunction(y));
    acc.add(y.value().chars());
    bool first = true;
    while(!iso().eoi()) {
      if(!first) acc.add(',');
      iso.access().getAnything(acc);
    };
  };
};

void ISource::get(Monomial&) {
  DBG();
};

void ISource::get(Term&) {
  DBG();
};

void ISource::get(Polynomial &) {
  DBG();
};

void ISource::get(GroebnerRule &) {
  DBG();
};

void ISource::print(void * v) {
  GBStream << "Source:" << v << "\nISource:" << this << "\nEOI:" 
           << d_eoi << '\n';
};

bool ISource::verror() const {
  return false;
};
