// NewFrontEnd.c

#include "memwatch.h"
#include "SetUp.hpp"
#include "Source.hpp"
#include "MyOstream.hpp"
#include "Sink.hpp"
#include "StartEnd.hpp"
#include "symbolGB.hpp"
#include "GBInputNumbers.hpp"
#include "Command.hpp"
#include "Choice.hpp"
#ifdef HAS_INCLUDE_NO_DOTS
#include <vector>
#else
#include <vector.h>
#endif

using namespace std;

#include "choose_mynew.hpp"
#ifdef MYNEW
#include "mynew.cpp"
#endif
 

int main(int argc, char * argv[]) {
  symbolGB name;
  AddingStart::s_print();
  AddingStart::s_execute();
  s_inInitialize = false;
  Source source;
  Sink sink;
  char * file = 0;
  if(argc==2) { 
    file = argv[1];
  } else {
    file = "code.nca";
    GBStream << "You should supply a filename.\n";
    GBStream << "The file name \"" << file << "\" is assumed.\n";
  };
  SetUp::s_CreateSourceSink(source,sink,file);
  while(source.getType()!=GBInputNumbers::s_IOEOF) {
    Source cmdsource(source.inputCommand(name));
    execute_command(name.value().chars(),cmdsource,sink);
    source.setNotEndOfInput();
  };
  return 0;
};
