// (c) Mark Stankus 1999
// PDPolySource.c

#include "PDPolySource.hpp"
#include "GBMatch.hpp"
#include "GiveNumber.hpp"
#include "GroebnerRule.hpp"
#include "Polynomial.hpp"
#include "MatcherMonomial.hpp"
#include "UserOptions.hpp"

PDPolySource::~PDPolySource() {};

void PDPolySource::insert(const RuleID &) {
  DBG();
};

void PDPolySource::remove(const RuleID &) {
  DBG();
};

void PDPolySource::fillForUnknownReason() {
  d_ints.access().fillForUnknownReason();
};

void PDPolySource::print(MyOstream & os) const {
  os << "Cannot output a polynomial source yet.\n";
};

#if 0
bool findRule(RuleID &,int,set<RuleID> &);
#endif

void PDPolySource::fillList() {
  const GroebnerRule & rule1 = d_give.fact(d_numbers.first);
  const GroebnerRule & rule2 = d_give.fact(d_numbers.second);
#if 0
  if(findRule(id1,d_numbers.first,d_active)) {
    if(findRule(id2,d_numbers.second,d_active)) {
#endif
      MatcherMonomial matcher;
      const Monomial & LHS1 = rule1.LHS(); // id1.poly().mono();
      const Monomial & LHS2 = rule2.LHS(); // id2.poly().mono();
      if(UserOptions::s_UseSubMatch) {
        matcher.subMatch(LHS1,d_numbers.first,LHS2,d_numbers.second,d_list);
      };
      matcher.overlapMatch(LHS1,d_numbers.first,LHS2,d_numbers.second,d_list);
#if 0
    };
  };
#endif
};

void PDPolySource::spolynomial(const Match & aMatch,
     Polynomial & result) const {
   const GroebnerRule & rule1 = d_give.fact(d_numbers.first);
   const GroebnerRule & rule2 = d_give.fact(d_numbers.second);
   Polynomial firstpart;
   firstpart.doubleProduct(aMatch.const_left1(),
                           rule1.RHS(),
                           aMatch.const_right1());
   Polynomial secondpart;
   secondpart.doubleProduct(aMatch.const_left2(),
                            rule2.RHS(),
                            aMatch.const_right2());
   result = firstpart;
   result -= secondpart;
}

void PDPolySource::setPerm(int n) {
  d_give.setPerm(n);
};

void PDPolySource::setNotPerm(int n) {
  d_give.setNotPerm(n);
};
