// PrintVector.c

#include "PrintVector.hpp"
#ifndef INCLUDED_DEBUG1_H
#include "Debug1.hpp"
#endif
#include "MyOstream.hpp"

template<class T>
void PrintVector(const char * s,const vector<T> & x) {
  GBStream << "The vector: " << s << '\n';
  vector<T>::const_iterator w = x.begin();
  const int sz = x.size();
  GBStream << '{';
  if(sz>0) {
    GBStream << * w << '\n';
    ++w;
    for(int i=2;i<=sz;++i,++w) {
      GBStream << ',' << * w << '\n';
    };
  };
  GBStream << "}\n";
};

#include "GroebnerRule.hpp"
template void PrintVector(const char *, const vector<bool> &);
template void PrintVector(const char *, const vector<int> &);
template void PrintVector(const char *, const vector<GroebnerRule> &);
template void PrintVector(const char *, const vector<Variable> &);
