// Mark Stankus 1999 (c)
// RecordToPolySource.c

#include "RecordToPolySource.hpp"
#include "TripleList.hpp"
#include "FactControl.hpp"
#include "PolynomialData.hpp"
#include "PolySource.hpp"

extern TripleList<int> * s_TripleList;

RecordToPolySource::~RecordToPolySource() {};

void RecordToPolySource::action(const BroadCastData & x) const {
  if(!x.cancast(PolynomialData::s_ID)) DBG();
  const PolynomialData  & y = (const PolynomialData  &) x;
  s_TripleList->addItem(y.d_number);
  d_ps.setPerm(y.d_number);
};

Recipient * RecordToPolySource::clone() const {
  return new RecordToPolySource(d_ps);
};
