// SetMLex.c

#include "CreateOrder.hpp"
#ifndef INCLUDED_GBINPUT_H
#include "GBInput.hpp"
#endif
#ifndef INCLUDED_GBOUTPUT_H
#include "GBOutput.hpp"
#endif
#include "Choice.hpp"
#ifndef INCLUDED_VECTOR_H
#define INCLUDED_VECTOR_H
#pragma warning(disable:4786)
#ifdef HAS_INCLUDE_NO_DOTS
#include <vector>
#else
#include <vector.h>
#endif
#endif
#ifndef INCLUDED_VARIABLE_H
#include "Variable.hpp"
#endif
#ifndef INCLUDED_MLEX_H
#include "MLex.hpp"
#endif
#ifndef INCLUDED_ORDERTYPE_H
#include "OrderType.hpp"
#endif
#include "Command.hpp"
#include "Source.hpp"
#include "Sink.hpp"

extern int s_number_of_spolynomials;

#include "vcpp.hpp"

void _SetMLex(Source & so,Sink & si) {
  vector<vector<Variable> > V2;
  GBInputSpecial(V2,so);
  so.shouldBeEnd();
  si.noOutput();
  setOrderAdopt(new MLex(V2));
};

AddingCommand temp1SetMLex("SetMLex",1,_SetMLex);

void _ClearNumberSpolynomials(Source & so,Sink & si) {
  s_number_of_spolynomials = 0; 
  so.shouldBeEnd();
  si.noOutput();
};

AddingCommand temp2SetMLex("ClearNumberSpolynomials",0,_ClearNumberSpolynomials);

void _GetNumberSpolynomials(Source & so,Sink & si) {
  so.shouldBeEnd();
  si << s_number_of_spolynomials; 
};

AddingCommand temp3SetMLex("GetNumberSpolynomials",0,_GetNumberSpolynomials);

void _PrintNumberSpolynomials(Source & so,Sink & si) {
  so.shouldBeEnd();
  GBStream << s_number_of_spolynomials; 
  si.noOutput();
};

AddingCommand temp4SetMLex("PrintNumberSpolynomials",0,_PrintNumberSpolynomials);
