// Mark Stankus 1999 (c)
// ToCompile.cpp

#include "Commands.hpp"
#include "Source.hpp"
#include "Sink.hpp"
#include "stringGB.hpp"

#include "Choice.hpp"
#ifdef HAS_INCLUDE_NO_DOTS
#include <set>
#include <map>
#else
#include <set.h>
#include <map.h>
#endif

using namespace std;

map<simpleString,set<simpleString,less<simpleString> >,less<simpleString> > 
  s_file_map;

void _FileImpliesFiles(Source & so,Sink & si) {
  stringGB x;
  list<stringGB> L;
  so >> x;
  so >> L;
  so.shouldBeEnd();
  typedef map<simpleString,set<simpleString,less<simpleString> > ,less<simpleString> >  MAP;
  MAP::iterator f = s_file_map.find(x.value());
  if(f==s_file_map.end()) {
    set<simpleString> S;
    pair<const simpleString,set<simpleString> > pr(x.value(),S);
    s_file_map.insert(pr);
    f = s_file_map.find(x.value());
  };
  list<stringGB>::const_iterator w = L.begin(), e = L.end(); 
  while(w!=e) {
    const stringGB & str = *w;
    if(x.value()!=str.value()) (*f).second.insert(str.value());
    ++w;
  };
  si.noOutput();
};Z

AddingCommand temp1ToCompile("FileImpliesFiles",2,_FileImpliesFiles);

void _FileImpliesWhat(Source & so,Sink & si) {
  typedef set<simpleString,less<simpleString> > SET;
  stringGB x;
  so >> x;
  so.shouldBeEnd();
  typedef map<simpleString,set<simpleString,less<simpleString> > 
         ,less<simpleString> >  MAP;
  MAP::iterator f = s_file_map.find(x.value());
  if(f==s_file_map.end()) {
    GBStream << "The file " << x.value().chars() << 
             << " has not been encounted in terms of dependency.\n";
  } else {
    GBStream << x.value().chars() << "::\n";
    const SET & S = (*f).second;
    while(w!=e) {
      const simpleString & y = *w;
      GBStream << y.value().chars() << '\n';
      ++w;
    }; 
  };
  si.noOutput();
};

AddingCommand temp2ToCompile("FileImpliesWhat",1,_FileImpliesWhat);

void _FileClosure(Source & so,Sink & si) {
  typedef map<simpleString,bool,less<simpleString> > MAP;
  typedef map<simpleString,set<simpleString,less<simpleString> >,less<simpleString> >  MAP2;
  typedef set<simpleString,less<simpleString> >  SET;
  list<stringGB> L;
  MAP  S;
  so >> L;
  so.shouldBeEnd();
  list<stringGB>::const_iterator w = L.begin(), e = L.end();
  while(w!=e) {
    pair<const simpleString,bool> pr((*w).value(),false);
    S.insert(pr);
    ++w;
  };
  bool done = false;
  while(!done) {
    done = true;
    MAP:const_iterator w = S.begin(), e = S.end();
    while(w!=e && done) {
      const pair<const simpleString,bool> & pr = *w;
      if(!pr.second) { 
        const simpleString & s = pr.first;
        MAP2::const_iterator w = s_file_map.find(s);
        if(w==s_file_map.end()) { 
          pr.second = true;
        } else {
          const SET &  SE = (*w).second;
          SET::const_iterator ww = SE.begin(), ee = SE.end();  
          if(ww==ee) {
            pr.second = true;
          } else {
          while(ww!=ee) {
            pair<const simpleString,bool> pr(*ww,false);
            if(S.insert(pr).second) done = false;
            ++ww;
          };
        };
      };
      ++w;
    };
  };
};
